jQuery(function() {

    renderList = function() {
        jQuery("#acs_sortable li").removeClass("even");
        jQuery("#acs_sortable li:even").addClass("even");
    }

    // tooltip
    jQuery(".acs_filter_help").tipTip({
        maxWidth: "400px",
        content: jQuery(this).find(".acs_help_text").html()
    });

    // sortable
    jQuery("#acs_sortable").sortable({
        axis: "y",
        create: renderList,
        stop: renderList
    });

    // load
    jQuery(".acs_option").click(function() {
        jQuery(this).find(".cb").toggleClass("on");
    });

    // ghost text
    jQuery("#acs_filter_input").keydown(function() {
        jQuery(".acs_ghost_text").html("");
    });

    // select box
    jQuery("#acs_select_box").click(function() {
        jQuery(this).toggleClass("active");
        jQuery("#acs_select_popup").toggle();
    });

    // add selected posts
    jQuery("#add-selected-posts").click(function() {
        jQuery(".acs_option span.cb.on").each(function() {
            var parent = jQuery(this).parent();
            var title = parent.find("span.acs_title").html();
            var post_id = parent.attr("rel");
            jQuery("#acs_sortable").append('<li><span class="acs_remove"></span><input type="hidden" name="acs[post_order][]" value="'+post_id+'" />'+title+'</li');
            jQuery(this).removeClass("on");
            parent.addClass("used");
            renderList();
        });
        jQuery("#acs_select_box").click();
    });

    // remove post
    jQuery(".acs_remove").live("click", function() {
        var parent = jQuery(this).parent();
        var post_id = parent.find("input").val();
        jQuery(".acs_option[rel="+post_id+"]").removeClass("used");
        parent.remove();
        renderList();
    });

    // filter select box options
    jQuery("#acs_filter_input").keyup(function() {

        var input = jQuery(this).val();
        var output = { types: [], keywords: [] };
        var pieces = output.keywords = input.split(" ");

        for (i in pieces) {
            var piece = pieces[i];
            if ("type:" == piece.substr(0, 5)) {
                output.types = piece.substr(5);
                if (output.types.indexOf(",") !== -1) {
                    output.types = output.types.split(",");
                }
                else {
                    output.types = [output.types];
                }
                output.keywords.splice(i, 1);
            }
        }
        output.keywords = output.keywords.join(" ");

        var regex = new RegExp(output.keywords, "i");

        // @TODO make further speed improvements
        jQuery("#acs_select_options > .acs_option:not(.used)").each(function() {

            var div = jQuery(this);
            var post_type = div.attr("type");

            if (output.types.length > 0 && jQuery.inArray(post_type, output.types) < 0) {
                div.addClass("hidden");
                return;
            }

            if (-1 < div.html().search(regex)) {
                div.removeClass("hidden");
            }
            else {
                div.addClass("hidden");
            }
        });
    });
});
